if (typeof(simplemail) == "undefined")
  var simplemail = {a: "mesagewindow.js"};

// userok
function SimpleMailWindowMessage_onKeyPress(e) {
  if (!e.ctrlKey || String.fromCharCode(e.charCode) != 'a')
    simplemail.messageTreeView.onKeyPress(e);
}

// userok: rewrited
function SimpleMailWindowMessage() {
  simplemail.overlay = simplemail.getBrowserWindow().simplemail.overlay;
  
  // get msg from param ".../message.xul?id"
  this.LMessage = simplemail.overlay.storage.getMessage(window.location.search.substr(1));
  //console.error("SM.SimpleMailWindowMessage( )", this.LMessage, window);//userok_log
  
  // userok; drop obsolete simplemail.domRemove("gr/ippy-style");
  this.initToolbarMode();
  
  // Important: Do not allow mail messages to execute javascript,
  // Because th/is javascript would be executed with chrome privileges
  var body = simplemail.domGet("body"); 
  body.docShell.allowJavascript = false;
  body.contentDocument.addEventListener("keypress", SimpleMailWindowMessage_onKeyPress, false);
  
  simplemail.messageTreeView.displayHeaders(this.LMessage);
  var html = this.LMessage.partial ? simplemail.Bundle.getString("messageNotDownloaded") : this.LMessage.html;
  var originalHTML = html;
  
  if (html !== " ") {
    var source = simplemail.SimpleMailFile.getAttachmentsDirectory(this.LMessage.attachmentsDir);
    source.append(simplemail.SimpleMailFile.MESSAGE_SOURCE);
    source = simplemail.SimpleMailFile.readFile(source);
  }
  
  if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive") && html !== " ") {
    var partAttachs = simplemail.messageTreeView.displayAttachments(html, this.LMessage);
    
    var attachments = [];
    simplemail.SimpleMailMessageEncoder.cidNames           = [];
    simplemail.SimpleMailMessageEncoder.ContentId          = [];
    simplemail.SimpleMailMessageEncoder.ContentDisposition = [];
    simplemail.SimpleMailMessageEncoder.ContentType        = [];
    var tmpMessage = simplemail.SimpleMailMessageEncoder.parse(source, attachments, simplemail.SimpleMailMessageEncoder.cidNames, simplemail.SimpleMailMessageEncoder.ContentId, simplemail.SimpleMailMessageEncoder.ContentDisposition, simplemail.SimpleMailMessageEncoder.ContentType);

    if (!source.match(/name\=/gim) && !source.match(/filename\=/gim) && !source.match(/Content\-ID\:/gim) || partAttachs == null) {  // No Attachments
      var html = simplemail.parseHTML(document, tmpMessage.html, true);
      html = simplemail.messageTreeView.plaintextMessage(html);
      html = html.replace(/(\r\n).*?/g,"<br>"); 
    } else {
      if (partAttachs != null) {
        partAttachs = partAttachs.join("");
      }      
      if (source.match(/text\/plain/gim)) { // Plaintext part
        var html = tmpMessage.html + "<br>" + partAttachs;
        var html = simplemail.parseHTML(document, html, true);
        html = simplemail.messageTreeView.plaintextMessage(html);
      } else {
        // Remove Inline images
        var getImages = tmpMessage.html.toString().match(/<img[^>]*>(.*?)>*/gim); 
        if (getImages != null) {
          for (var i in getImages)
            tmpMessage.html = tmpMessage.html.replace(getImages[i], "");
        }
        var html = simplemail.parseHTML(document, tmpMessage.html, true);
        html = simplemail.messageTreeView.plaintextMessage(html);
        html = html.replace(/(\r\n).*?/g,"<br>");   
        html = html  + "<br>" + partAttachs;
      }
    }

    if (!(simplemail.overlay.storage.getMessage(this.LMessage.id).html).match(/\<a\sclass\=\'attachment\'/gim)) {
      this.LMessage.html = originalHTML;
      simplemail.overlay.storage.updateMessage(0, this.LMessage); // userok: async
    }
  } else
    html = simplemail.messageTreeView.displayAttachments(html, this.LMessage);
  
  html = simplemail.SimpleMailText.imageToLink(html);
  
  // Change : remove : i don't remember what does th/is does !!
  /*if (html !== " " && source.toString().match(/Content\-Type\: text\/plain/gim) && simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
    html = simplemail.SimpleMailText.linkToLink(html);
  } */
  
  body.contentDocument.title = this.LMessage.subject;
  
  if (simplemail.SimpleMailPrefs.getBool("plaintextOnReceive")) {
    var getHtmlImages = html.toString().match(/<img[^>]*>(.*?)>*/gim);
    if (getHtmlImages != null) {
      for (var k in getHtmlImages) { 
        if (getHtmlImages[k].match(/http/gim))
          var html = html.replace(getHtmlImages[k], simplemail.Bundle.getString("removedimages"));
      }
    }
    html = simplemail.SimpleMailText.linkToText(html);
  }
  
  // userok
  var fragment = simplemail.parseHTML(body.contentDocument, html, true, simplemail.SimpleMailPrefs.getBool('blockmedia'));
  body.contentDocument.body.innerHTML = "";
  body.contentDocument.body.appendChild(fragment);
  
  if (this.LMessage.returnReceiptTo && this.LMessage.uid && !this.LMessage.partial)
    simplemail.messageTreeView.sendReturnReceipt(this.LMessage);

  clearTimeout(simplemail.messageTreeView.markReadTimeout);
  
  if (!this.LMessage.read && !this.LMessage.partial)
    simplemail.messageTreeView.startMarkReadTimeout(this.LMessage);
}

SimpleMailWindowMessage.prototype.initToolbarMode = function() {
  var mode = simplemail.SimpleMailPrefs.getString("toolbarMode");
  simplemail.domGet("simplemail-toolbar").setAttribute("mode", mode);

  var menuitems = simplemail.domGet("toolbar-menu").childNodes;
  for (var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].value == mode)
      menuitems[i].setAttribute("checked", true);
  }
  
  if (simplemail.SimpleMailPrefs.getBool("old")) {
    simplemail.domRemove("nuvola-style");
    simplemail.domRemove("oxygen-style");
    simplemail.domRemove("australis-style");
  } else if (simplemail.SimpleMailPrefs.getBool("nuvola")) {
    simplemail.domRemove("old-style");
    simplemail.domRemove("oxygen-style");
    simplemail.domRemove("australis-style");
  } else if (simplemail.SimpleMailPrefs.getBool("oxygen")) {
    simplemail.domRemove("old-style");
    simplemail.domRemove("nuvola-style");
    simplemail.domRemove("australis-style");
  } else if (simplemail.SimpleMailPrefs.getBool("australis")) {
    simplemail.domRemove("old-style");
    simplemail.domRemove("nuvola-style");
    simplemail.domRemove("oxygen-style");
  }
}

SimpleMailWindowMessage.prototype.updateToolbarMode = function() {
  var menuitems = simplemail.domGet("toolbar-menu").childNodes;
  for (var i = 0; i < menuitems.length; i++) {
    if (menuitems[i].getAttribute("checked")) {
      simplemail.SimpleMailPrefs.setString("toolbarMode", menuitems[i].value);
      simplemail.domGet("simplemail-toolbar").setAttribute("mode", menuitems[i].value);
    }
  }
}

// userok: unused? SimpleMailWindowMessage.prototype.updateFavIcon = function() {
//  console.error("SM.msgwnd_updateFavIcon");//userok_log
//  var tab      = simplemail.getDocumentTab(document);
//  var gBrowser = simplemail.getBrowser();
//  var status   = simplemail.overlay.getStatus();
//  var icon     = simplemail.SimpleMailFile.getStatusIconURL(status);
//  gBrowser.setIcon(tab, icon);
//}

// userok: rewrited
SimpleMailWindowMessage.prototype.reply = function(all) {
  //console.error("SM.messagewindow_reply", this);//userok_log
  if (!simplemail.SimpleMailPrefs.getBool("newMessagesInWindow"))
    simplemail.overlay.refreshTab("chrome://simplemail/content/main/main.xul");

  setTimeout(function(_this) {
    simplemail.SimpleMailPrefs.setString('originalId', _this.LMessage.id);
    var nMsg = _this.LMessage.createReply(all);
    simplemail.overlay.openNewMessage(nMsg);
  }, 250, this);
}

// userok: rewrited
SimpleMailWindowMessage.prototype.forward = function() {
  //console.error("SM.messagewindow_forward", this);//userok_log
  if (!simplemail.SimpleMailPrefs.getBool("newMessagesInWindow"))
    simplemail.overlay.refreshTab("chrome://simplemail/content/main/main.xul");

  setTimeout(function(_this) {
    simplemail.SimpleMailPrefs.setString('originalId', _this.LMessage.id);
    var nMsg = _this.LMessage.createForward();
    simplemail.overlay.openNewMessage(nMsg);
  }, 250, this);
}

// userok: rewrited
SimpleMailWindowMessage.prototype.saveMessageAs = function() {
  simplemail.messageTreeView.dosaveMessageAs(this.LMessage);
}      

// userok: rewrited
SimpleMailWindowMessage.prototype.print = function() {
  simplemail.messageTreeView.doprintMessage(this.LMessage);
}

SimpleMailWindowMessage.prototype.deleteThisMail = function() {
  if (this.LMessage.folderId != simplemail.Folder.TRASH & simplemail.SimpleMailPrefs.getBool("moveToTrash")) {
    this.LMessage.folderId = simplemail.Folder.TRASH;
    
    // Manage SPAMs
    if (this.LMessage.folderId == simplemail.SimpleMailManageFolder.getFolderId("SPAM")) {
      this.LMessage.spam = true;
      var messageFrom    = this.LMessage.from;
      processFilterSPAM(messageFrom);
    } else if (this.LMessage.folderId !== simplemail.SimpleMailManageFolder.getFolderId("SPAM") && this.LMessage.spam == true) {
      this.LMessage.spam = false;
      var messageFrom    = this.LMessage.from;
      deleteRuleFilterSPAM(messageFrom);
    }
    simplemail.overlay.storage.saveMessageState(this.LMessage); // userok
  } else {
    var msgs = [];
    msgs.push(this.LMessage);
    var confirmText = simplemail.Bundle.getString("deleteMessages");
    simplemail.overlay.askDeleteMail(msgs, confirmText, window);
  }
  
  var mainWindow = simplemail.overlay.getMainWindow(true);
  window.close();
  if (mainWindow) 
    mainWindow.history.go();
}

SimpleMailWindowMessage.prototype.onClose = function() {

}