var spamFolderId; // userok: declare global var

// Create Folder SPAM // userok: async
function addFolderSPAM() {
  var spamFolder  = "SPAM";
  var folderSPAM  = new simplemail.Folder(null, null, spamFolder);
  folderTree.view = simplemail.folderTreeView; 
  simplemail.SimpleMailManageFolder.setFolderParent(function(fldr, pid) {
    folders         = simplemail.overlay.storage.getFolders();
    folderTree      = simplemail.domGet("folder-tree");
    folderTree.view = simplemail.folderTreeView;
    simplemail.SimpleMailManageFolder.updateFolderCounts();
    spamFolderId    = fldr.id;    
  }, folderSPAM, 0);
}

function getSPAMFolderId(folderSPAM) {
  return simplemail.SimpleMailManageFolder.getFolderId(folderSPAM);
}

// Check if SPAM folder exist and get ID
function checkfolderSPAM() {
  spamFolderId = getSPAMFolderId("SPAM");

  if (typeof(spamFolderId) == 'undefined' && simplemail.SimpleMailPrefs.getBool("movespam"))
    addFolderSPAM();
}

function getSPAMFilter() {
  var spamName = "SPAM";
  var tfilters = simplemail.overlay.storage.getFilters();
  for (var i in tfilters) {
    if (tfilters[i].name == spamName)
      return tfilters[i];
  }
  // Create Filter
  var filterSPAM = new simplemail.Filter(null, null, spamName, 1, [], []);
  simplemail.overlay.storage.saveFilter(0, filterSPAM); // userok: async
  return filterSPAM;
}

function toggletoSpam() {
  var spam = false;
  
  if (simplemail.SimpleMailPrefs.getBool("nospam"))
    return;
  
  if (simplemail.SimpleMailPrefs.getBool("movespam"))
    checkfolderSPAM();
  
  simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    spam |= !simplemail.messageTreeView.messages[index].spam;
  });

  simplemail.messageTreeView.forEachMessagesSelected(function(index) {
    if (simplemail.messageTreeView.messages[index].spam == 1) {
      var deleted = new Array();
      var message = simplemail.messageTreeView.messages[index];
      simplemail.messageTreeView.messages[index].folderId = simplemail.Folder.INBOX;
      if (simplemail.messageTreeView.messages[index].read == 1) {
        var message = simplemail.messageTreeView.messages[index];
        message.read = false;
      }
      message.spam = false;
      simplemail.overlay.storage.saveMessageState(message);
      deleted.push(simplemail.messageTreeView.messages[index]);
      simplemail.messageTreeView.onMessagesDeleted(deleted);
      folders         = simplemail.overlay.storage.getFolders();
      folderTree      = simplemail.domGet("folder-tree");
      folderTree.view = simplemail.folderTreeView;
      simplemail.SimpleMailManageFolder.updateFolderCounts();
      simplemail.overlay.updateIcons();
      var messageFrom = message.from;
      deleteRuleFilterSPAM(messageFrom);
    } else if (simplemail.messageTreeView.messages[index].spam  == 0) {
      var message = simplemail.messageTreeView.messages[index];
      var messageFrom = message.from;
      markSpam(index, spam);
      processFilterSPAM(messageFrom);
    } 
  });
}

// Mark spam message
function markSpam(index, spam) {
  // Mark read
  if (simplemail.SimpleMailPrefs.getBool("markspamasread")) {
    simplemail.messageTreeView.forEachMessagesSelected(function(index) {
      if (simplemail.messageTreeView.messages[index].read == 0) {
        var message = simplemail.messageTreeView.messages[index];
        message.read = true;
      }
    })  
  }

  // Manage spam
  if (simplemail.SimpleMailPrefs.getBool("movespam") && simplemail.SimpleMailManageFolder.getCurrentFolder().id != spamFolderId) {
    var deleted = new Array();
    simplemail.messageTreeView.messages[index].folderId = spamFolderId;
    simplemail.messageTreeView.messages[index].spam     = true;  
    simplemail.overlay.storage.saveMessageState(simplemail.messageTreeView.messages[index]);
    deleted.push(simplemail.messageTreeView.messages[index]);
    simplemail.messageTreeView.onMessagesDeleted(deleted);
  }
  else if (simplemail.SimpleMailPrefs.getBool("trashspam") && simplemail.SimpleMailManageFolder.getCurrentFolder().id != simplemail.Folder.TRASH) {
    var deleted = new Array();
    simplemail.messageTreeView.messages[index].folderId = simplemail.Folder.TRASH;
    simplemail.messageTreeView.messages[index].spam = true;
    simplemail.overlay.storage.saveMessageState(simplemail.messageTreeView.messages[index]);
    deleted.push(simplemail.messageTreeView.messages[index]);
    simplemail.messageTreeView.onMessagesDeleted(deleted);
  }
  else if (simplemail.SimpleMailPrefs.getBool("deletespam") && simplemail.SimpleMailManageFolder.getCurrentFolder().id != simplemail.Folder.TRASH) {
    simplemail.messageTreeView.deleteMail(true);
  }

  folders = simplemail.overlay.storage.getFolders();
  folderTree = simplemail.domGet("folder-tree");
  folderTree.view = simplemail.folderTreeView;
  simplemail.SimpleMailManageFolder.updateFolderCounts();
  simplemail.overlay.updateIcons();
}

function processFilterSPAM(messageFrom) {
  // Check change of action
  checkChangeActions();
  addRuleFilterSPAM(messageFrom);
}

function checkChangeActions() {
  if (simplemail.SimpleMailPrefs.getBool("nospam")) {
    deleteActionFilterSPAM();
  } else {
    var filterSPAM = getSPAMFilter(); // userok
    if (filterSPAM.actions == "")
      addActionFilterSPAM();
    
    for (var i in filterSPAM.actions) {
      if (simplemail.SimpleMailPrefs.getBool("trashspam") && filterSPAM.actions[i].param != simplemail.Folder.TRASH) {
        deleteActionFilterSPAM();
        addActionFilterSPAM();
      }
      if (simplemail.SimpleMailPrefs.getBool("deletespam") && filterSPAM.actions[i].param != "delete"){
        deleteActionFilterSPAM();
        addActionFilterSPAM();
      }
      if (simplemail.SimpleMailPrefs.getBool("movespam")) {
        checkfolderSPAM();
        if (filterSPAM.actions[i].param != spamFolderId) {
          deleteActionFilterSPAM();
          addActionFilterSPAM();
        }
      }
    }
  } 
}

function addRuleFilterSPAM(messageFrom) {
  // Get filter Object
  var filterSPAM = getSPAMFilter(); // userok
  // Check if rule exist
  for (var i in filterSPAM.rules) {
    if (filterSPAM.rules[i].param == messageFrom)
      return;
  }
  var ruleParam = messageFrom;
  var rule      = simplemail.overlay.storage.createRule(null, nameFilterSPAMId, "from", 0, "contains", ruleParam);
  filterSPAM.rules.push(rule);
  simplemail.overlay.storage.saveFilter(0, filterSPAM); // userok: async
}

function addActionFilterSPAM() {
  var filterSPAM = getSPAMFilter(); // userok
  
  if (simplemail.SimpleMailPrefs.getBool("movespam")) {
    spamFolderId = getSPAMFolderId("SPAM");
    actionName   = "folder";
    actionParam  = "text: " + spamFolderId;
  } else if (simplemail.SimpleMailPrefs.getBool("trashspam")) {
    actionName   = "folder";
    actionParam  = "text: " + simplemail.Folder.TRASH;
  } else if (simplemail.SimpleMailPrefs.getBool("deletespam")) {
    actionName   = "delete";
    actionParam  = "";
  }
  
  var action = simplemail.overlay.storage.createAction(null, nameFilterSPAMId, actionName, actionParam);
  filterSPAM.actions.push(action);
  simplemail.overlay.storage.saveFilter(0, filterSPAM); // userok: async
}

// userok: async
function deleteRuleFilterSPAM(messageFrom) {
  var filterSPAM = getSPAMFilter(); // userok
  // Check if rule exist
  for (var i in filterSPAM.rules) {
    if (filterSPAM.rules[i].param == messageFrom) {
      deleteFilterRule(0, filterSPAM.id, filterSPAM.rules[i].id); // userok
      //!userok: what for? simplemail.overlay.storage.saveFilter(0, filterSPAM); // userok: async
    }
  }
}

// userok: async
function deleteActionFilterSPAM() {
  var filterSPAM = getSPAMFilter(); // userok
  for (var i in filterSPAM.actions) {
    deleteFilterAction(0, filterSPAM.id, filterSPAM.actions[i].id); // userok: async
    //!userok: what for? simplemail.overlay.storage.saveFilter(0, filterSPAM); // userok: async
  }
}