// userok
function getAutoConfigBase() {
  return [{d: ["mail.telenor.dk","vip.cybercity.dk","post.cybercity.dk","email.dk","mobil.dk","privatmail.dk","info.dk","io.dk","it.dk","film.dk","worldonline.dk","wol.dk","1031.inord.dk","123mail.dk","12fuel.dk","12mail.dk","12move.dk","2senior.dk","anarki.dk","anderledes.dk","begavet.dk","bitnisse.dk","city.dk","cool.dk","cyberdude.dk","cyberjunkie.dk","dk2net.dk","dk-online.dk","elinstallatoer.dk","elsker.dk","elvis.dk","fald.dk","fedt.dk","feminin.dk","forening.dk","gadefejer.dk","gason.dk","grin.dk","grov.dk","hardworking.dk","heaven.dk","hemmelig.dk","huleboer.dk","image.dk","inbound.dk","indbakke.dk","infile.dk","jyde.dk","klog.dk","knus.dk","krudt.dk","kulturel.dk","larsen.dk","lazy.dk","lystig.dk","mail.dia.dk","maskulin.dk","min-postkasse.dk","musling.dk","natteliv.dk","netbruger.dk","pedal.dk","pengemand.dk","pokerface.dk","post.dia.dk","postman.dk","privat.dia.dk","quake.dk","ready.dk","secret.dk","sleepy.dk","sporty.dk","superbruger.dk","talent.dk","tanke.dk","taxidriver.dk","teens.dk","teknik.dk","tjekket.dk","traceroute.dk","tv.dk","ugenstilbud.dk","ungdom.dk","video.dk","vittig.dk"], imap: {h: "mail.telenor.dk", p: 143, t: "tls"}, pop3: {h: "mail.telenor.dk", p: 110, t: "tls"}, smtp: {h: "mail.telenor.dk", p: 587, t: "tls"}},
    {d: ["126.com"], imap: {h: "imap.126.com", p: 993, t: "ssl"}, smtp: {h: "smtp.126.com", p: 465, t: "ssl"}},
    {d: ["163.com"], imap: {h: "imap.163.com", p: 993, t: "ssl"}, smtp: {h: "smtp.163.com", p: 465, t: "ssl"}},
    {d: ["1and1.de","online.de","onlinehome.de","sofortstart.de","sofort-start.de","sofortsurf.de","sofort-surf.de","go4more.de","kundenserver.de","schlund.de","1and1.com","1and1.fr","1and1.co.uk","1and1.es"], imap: {h: "imap.1und1.de", p: 993, t: "ssl"}, pop3: {h: "pop.1und1.de", p: 995, t: "ssl"}, smtp: {h: "smtp.1und1.de", p: 587, t: "tls"}},
    {d: ["a1.net","aon.at"], imap: {h: "securemail.a1.net", p: 993, t: "ssl"}, smtp: {h: "securemail.a1.net", p: 587, t: "tls"}},
    {d: ["abc.plala.or.jp"], pop3: {h: "abc.mail.plala.or.jp", p: 110}, smtp: {h: "abc.mail.plala.or.jp", p: 587}},
    {d: ["mail.com","mail.org","email.com","post.com","usa.com","accountant.com","consultant.com","dr.com","engineer.com","cheerful.com","techie.com","linuxmail.org","europe.com","london.com","uymail.com","myself.com","iname.com","writeme.com","2die4.com","activist.com","adexec.com","africamail.com","aircraftmail.com","alabama.usa.com","alaska.usa.com","allergist.com","alumni.com","alumnidirector.com","americamail.com","amorous.com","angelic.com","archaeologist.com","arizona.usa.com","artlover.com","asia-mail.com","atheist.com","australiamail.com","bartender.net","berlin.com","bigger.com","bikerider.com","birdlover.com","blader.com","boardermail.com","brazilmail.com","brew-master.com","california.usa.com","californiamail.com","caress.com","catlover.com","chef.net","chemist.com","chinamail.com","clerk.com","cliffhanger.com","collector.org","columnist.com","comic.com","computer4u.com","contractor.net","coolsite.net","counsellor.com","count.com","couple.com","cutey.com","cyberdude.com","cybergal.com","cyber-wizard.com","dallasmail.com","dbzmail.com","deliveryman.com","diplomats.com","disciples.com","doctor.com","doglover.com","doramail.com","dublin.com","earthling.net","elvisfan.com","englandmail.com","europemail.com","execs.com","fan.com","feelings.com","financier.com","fireman.net","florida.usa.com","footballer.com","gardener.com","geologist.com","germanymail.com","graduate.org","graphic-designer.com","hackermail.com","hairdresser.net","hilarious.com","hockeymail.com","homemail.com","hot-shot.com","hour.com","humanoid.net","illinois.usa.com","innocent.com","inorbit.com","instruction.com","instructor.net","insurer.com","irelandmail.com","italymail.com","japan.com","journalist.com","keromail.com","kittymail.com","koreamail.com","lawyer.com","legislator.com","loveable.com","lovecat.com","mad.scientist.com","madonnafan.com","madrid.com","marchmail.com","mexicomail.com","mindless.com","minister.com","mobsters.com","monarchy.com","moscowmail.com","munich.com","musician.org","muslim.com","newyork.usa.com","null.net","nycmail.com","oath.com","optician.com","pacificwest.com","petlover.com","photographer.net","playful.com","poetic.com","politician.com","popstar.com","presidency.com","priest.com","programmer.net","publicist.com","realtyagent.com","reborn.com","reggaefan.com","religious.com","repairman.com","representative.com","rescueteam.com","revenue.com","rocketship.com","rockfan.com","rome.com","royal.net","saintly.com","salesperson.net","sanfranmail.com","scientist.com","scotlandmail.com","secretary.net","seductive.com","singapore.com","snakebite.com","songwriter.net","soon.com","spainmail.com","teachers.org","technologist.com","texas.usa.com","thegame.com","therapist.net","toke.com","tokyo.com","toothfairy.com","tvstar.com","umpire.com","wallet.com","webname.com","weirdness.com","who.net","whoever.com","winning.com","witty.com","worker.com","workmail.com","yours.com"], imap: {h: "imap.mail.com", p: 993, t: "ssl"}, pop3: {h: "pop.mail.com", p: 995, t: "ssl"}, smtp: {h: "smtp.mail.com", p: 465, t: "ssl"}},
    {d: ["active24.com","smtp.cz"], imap: {h: "email.active24.com", p: 993, t: "ssl"}, pop3: {h: "email.active24.com", p: 995, t: "ssl"}, smtp: {h: "email.active24.com", p: 465, t: "ssl"}},
    {d: ["agate.plala.or.jp"], pop3: {h: "agate.mail.plala.or.jp", p: 110}, smtp: {h: "agate.mail.plala.or.jp", p: 587}},
    {d: ["aol.com","aim.com","netscape.net"], imap: {h: "imap.aol.com", p: 993, t: "ssl"}, pop3: {h: "pop.aol.com", p: 995, t: "ssl"}, smtp: {h: "smtp.aol.com", p: 587, t: "tls"}},
    {d: ["alice.it"], imap: {h: "in.alice.it", p: 143}, pop3: {h: "in.alice.it", p: 110}, smtp: {h: "out.alice.it", p: 587}},
    {d: ["amail.plala.or.jp"], pop3: {h: "amail.mail.plala.or.jp", p: 110}, smtp: {h: "amail.mail.plala.or.jp", p: 587}},
    {d: ["amber.plala.or.jp"], pop3: {h: "amber.mail.plala.or.jp", p: 110}, smtp: {h: "amber.mail.plala.or.jp", p: 587}},
    {d: ["ameritech.net","att.net","bellsouth.net","flash.net","nvbell.net","pacbell.net","prodigy.net","sbcglobal.net","snet.net","swbell.net","wans.net"], pop3: {h: "inbound.att.net", p: 995, t: "ssl"}, smtp: {h: "outbound.att.net", p: 465, t: "ssl"}},
    {d: ["garnet.broba.cc","amethyst.broba.cc","coral.broba.ccv","diamond.broba.cc"], pop3: {h: "mail.broba.cc", p: 110}, smtp: {h: "mail.broba.cc", p: 587}},
    {d: ["apost.plala.or.jp"], pop3: {h: "apost.mail.plala.or.jp", p: 110}, smtp: {h: "apost.mail.plala.or.jp", p: 587}},
    {d: ["aqua.plala.or.jp"], pop3: {h: "aqua.mail.plala.or.jp", p: 110}, smtp: {h: "aqua.mail.plala.or.jp", p: 587}},
    {d: ["arcor.de"], imap: {h: "imap.arcor.de", p: 993, t: "ssl"}, pop3: {h: "pop3.arcor.de", p: 995, t: "ssl"}, smtp: {h: "mail.arcor.de", p: 465, t: "ssl"}},
    {d: ["onet.pl","onet.eu","poczta.onet.pl","poczta.onet.eu","op.pl","vp.pl","autograf.pl","buziaczek.pl","amorki.pl","republika.pl"], pop3: {h: "pop3.poczta.onet.pl", p: 995, t: "ssl"}, smtp: {h: "smtp.poczta.onet.pl", p: 465, t: "ssl"}},
    {d: ["ballade.plala.or.jp"], pop3: {h: "ballade.mail.plala.or.jp", p: 110}, smtp: {h: "ballade.mail.plala.or.jp", p: 587}},
    {d: ["bay.wind.ne.jp","bay.wind.jp","bay.wind.co.jp","bay.gunmanet.or.jp","bay.gunmanet.ne.jp"], pop3: {h: "bay.wind.ne.jp", p: 110}, smtp: {h: "bay.wind.ne.jp", p: 587}},
    {d: ["bb-niigata.jp"], pop3: {h: "pop.bb-niigata.jp", p: 110}, smtp: {h: "pop.bb-niigata.jp", p: 25}},
    {d: ["beige.plala.or.jp"], pop3: {h: "beige.mail.plala.or.jp", p: 110}, smtp: {h: "beige.mail.plala.or.jp", p: 587}},
    {d: ["skynet.be","proximus.be","belgacom.net","kidcity.be"], imap: {h: "imap.proximus.be", p: 993, t: "ssl"}, pop3: {h: "pop.proximus.be", p: 485, t: "ssl"}, smtp: {h: "relay.proximus.be", p: 587, t: "tls"}},
    {d: ["bell.net","sympatico.ca"], imap: {h: "imap.bell.net", p: 993, t: "ssl"}, pop3: {h: "pophm.sympatico.ca", p: 995, t: "ssl"}, smtp: {h: "smtphm.sympatico.ca", p: 587, t: "tls"}},
    {d: ["biglobe.ne.jp"], pop3: {h: "mail.biglobe.ne.jp", p: 110}, smtp: {h: "mail.biglobe.ne.jp", p: 587}},
    {d: ["bigpond.com","bigpond.net.au","telstra.com","bigpond.net"], pop3: {h: "mail.bigpond.com", p: 995, t: "ssl"}, smtp: {h: "mail.bigpond.com", p: 25}},
    {d: ["blue.plala.or.jp"], pop3: {h: "blue.mail.plala.or.jp", p: 110}, smtp: {h: "blue.mail.plala.or.jp", p: 587}},
    {d: ["bluemail.ch"], imap: {h: "imaps.bluewin.ch", p: 993, t: "ssl"}, pop3: {h: "pop3s.bluewin.ch", p: 995, t: "ssl"}, smtp: {h: "smtpauths.bluewin.ch", p: 465, t: "ssl"}},
    {d: ["bluewin.ch"], imap: {h: "imaps.bluewin.ch", p: 993, t: "ssl"}, pop3: {h: "pop3s.bluewin.ch", p: 995, t: "ssl"}, smtp: {h: "smtpauths.bluewin.ch", p: 465, t: "ssl"}},
    {d: ["blueyonder.co.uk"], imap: {h: "imap4.blueyonder.co.uk", p: 993, t: "ssl"}, pop3: {h: "pop3.blueyonder.co.uk", p: 995, t: "ssl"}, smtp: {h: "smtp.blueyonder.co.uk", p: 465, t: "ssl"}},
    {d: ["bmail.plala.or.jp"], pop3: {h: "bmail.mail.plala.or.jp", p: 110}, smtp: {h: "bmail.mail.plala.or.jp", p: 587}},
    {d: ["bol.com.br"], imap: {h: "imap.bol.com.br", p: 993, t: "ssl"}, pop3: {h: "pop3.bol.com.br", p: 995, t: "ssl"}, smtp: {h: "smtps.bol.com.br", p: 465, t: "ssl"}},
    {d: ["bolero.plala.or.jp"], pop3: {h: "bolero.mail.plala.or.jp", p: 110}, smtp: {h: "bolero.mail.plala.or.jp", p: 587}},
    {d: ["bpost.plala.or.jp"], pop3: {h: "bpost.mail.plala.or.jp", p: 110}, smtp: {h: "bpost.mail.plala.or.jp", p: 587}},
    {d: ["brown.plala.or.jp"], pop3: {h: "brown.mail.plala.or.jp", p: 110}, smtp: {h: "brown.mail.plala.or.jp", p: 587}},
    {d: ["btinternet.com","btopenworld.com","talk21.com"], imap: {h: "mail.btinternet.com", p: 993, t: "ssl"}, pop3: {h: "mail.btinternet.com", p: 995, t: "ssl"}, smtp: {h: "mail.btinternet.com", p: 465, t: "ssl"}},
    {d: ["camel.plala.or.jp"], pop3: {h: "camel.mail.plala.or.jp", p: 110}, smtp: {h: "camel.mail.plala.or.jp", p: 587}},
    {d: ["cameo.plala.or.jp"], pop3: {h: "cameo.mail.plala.or.jp", p: 110}, smtp: {h: "cameo.mail.plala.or.jp", p: 587}},
    {d: ["ziggo.nl","casema.nl","quicknet.nl","home.nl"], pop3: {h: "pop.ziggo.nl", p: 110}, smtp: {h: "smtp.ziggo.nl", p: 587, t: "tls"}},
    {d: ["cc9.ne.jp"], pop3: {h: "pop.cc9.ne.jp", p: 110}, smtp: {h: "smtp.cc9.ne.jp", p: 25}},
    {d: ["cek.ne.jp"], pop3: {h: "mail.cek.ne.jp", p: 110}, smtp: {h: "smtp.cek.ne.jp", p: 25}},
    {d: ["centurylink.net","embarqmail.com"], imap: {h: "mail.centurylink.net", p: 993, t: "ssl"}, pop3: {h: "pop.centurylink.net", p: 995, t: "ssl"}, smtp: {h: "smtp.centurylink.net", p: 587, t: "tls"}},
    {d: ["centurytel.net","clds.net","coastalnow.net","cochill.net","cswnet.com","emadisonriver.com","emadisonriver.net","gallatinriver.net","grics.net","gulftel.com","madisonriver.biz","mebtel.net"], pop3: {h: "pop.centurytel.net", p: 995, t: "ssl"}, smtp: {h: "smtpauth.centurytel.net", p: 587, t: "tls"}},
    {d: ["cgl.ucsf.edu"], imap: {h: "plato.cgl.ucsf.edu", p: 993, t: "ssl"}, smtp: {h: "plato.cgl.ucsf.edu", p: 587, t: "tls"}},
    {d: ["charter.net","charter.com"], imap: {h: "mobile.charter.net", p: 993, t: "ssl"}, pop3: {h: "pop.charter.net", p: 110}, smtp: {h: "mobile.charter.net", p: 587, t: "ssl"}},
    {d: ["clio.ne.jp"], pop3: {h: "mail.clio.ne.jp", p: 110}, smtp: {h: "mail.clio.ne.jp", p: 587}},
    {d: ["sfr.fr","neuf.fr","club-internet.fr"], imap: {h: "imap.sfr.fr", p: 993, t: "ssl"}, pop3: {h: "pop.sfr.fr", p: 995, t: "ssl"}, smtp: {h: "smtp.sfr.fr", p: 465, t: "ssl"}},
    {d: ["cmail.plala.or.jp"], pop3: {h: "cmail.mail.plala.or.jp", p: 110}, smtp: {h: "cmail.mail.plala.or.jp", p: 587}},
    {d: ["co1.wind.ne.jp","co1.wind.jp"], pop3: {h: "co1.wind.ne.jp", p: 110}, smtp: {h: "co1.wind.ne.jp", p: 587}},
    {d: ["co2.wind.ne.jp","co2.wind.jp"], pop3: {h: "co2.wind.ne.jp", p: 110}, smtp: {h: "co2.wind.ne.jp", p: 587}},
    {d: ["co3.wind.ne.jp","co3.wind.jp"], pop3: {h: "co3.wind.ne.jp", p: 110}, smtp: {h: "co3.wind.ne.jp", p: 587}},
    {d: ["cocoa.plala.or.jp"], pop3: {h: "cocoa.mail.plala.or.jp", p: 110}, smtp: {h: "cocoa.mail.plala.or.jp", p: 587}},
    {d: ["coda.plala.or.jp"], pop3: {h: "coda.mail.plala.or.jp", p: 110}, smtp: {h: "coda.mail.plala.or.jp", p: 587}},
    {d: ["comcast.net"], imap: {h: "imap.comcast.net", p: 993, t: "ssl"}, pop3: {h: "mail.comcast.net", p: 995, t: "ssl"}, smtp: {h: "smtp.comcast.net", p: 465, t: "ssl"}},
    {d: ["concerto.plala.or.jp"], pop3: {h: "concerto.mail.plala.or.jp", p: 110}, smtp: {h: "concerto.mail.plala.or.jp", p: 587}},
    {d: ["coral.plala.or.jp"], pop3: {h: "coral.mail.plala.or.jp", p: 110}, smtp: {h: "coral.mail.plala.or.jp", p: 587}},
    {d: ["courante.plala.or.jp"], pop3: {h: "courante.mail.plala.or.jp", p: 110}, smtp: {h: "courante.mail.plala.or.jp", p: 587}},
    {d: ["cox.net"], imap: {h: "imap.cox.net", p: 993, t: "ssl"}, pop3: {h: "pop.cox.net", p: 995, t: "ssl"}, smtp: {h: "smtp.cox.net", p: 465, t: "ssl"}},
    {d: ["cpost.plala.or.jp"], pop3: {h: "cpost.mail.plala.or.jp", p: 110}, smtp: {h: "cpost.mail.plala.or.jp", p: 587}},
    {d: ["cream.plala.or.jp"], pop3: {h: "cream.mail.plala.or.jp", p: 110}, smtp: {h: "cream.mail.plala.or.jp", p: 587}},
    {d: ["dan.wind.ne.jp","dan.wind.jp","dan.wind.co.jp","dan.gunmanet.or.jp","dan.gunmanet.ne.jp"], pop3: {h: "dan.wind.ne.jp", p: 110}, smtp: {h: "dan.wind.ne.jp", p: 587}},
    {d: ["dance.plala.or.jp"], pop3: {h: "dance.mail.plala.or.jp", p: 110}, smtp: {h: "dance.mail.plala.or.jp", p: 587}},
    {d: ["dd.iij4u.or.jp","ff.iij4u.or.jp","hh.iij4u.or.jp","kk.iij4u.or.jp","nn.iij4u.or.jp","pp.iij4u.or.jp","rr.iij4u.or.jp","ss.iij4u.or.jp","bc.iij4u.or.jp","bk.iij4u.or.jp","bp.iij4u.or.jp","bu.iij4u.or.jp"], pop3: {h: "mbox.iij4u.or.jp", p: 110, t: "tls"}, smtp: {h: "mbox.iij4u.or.jp", p: 587, t: "tls"}},
    {d: ["dmail.plala.or.jp"], pop3: {h: "dmail.mail.plala.or.jp", p: 110}, smtp: {h: "dmail.mail.plala.or.jp", p: 587}},
    {d: ["iijmio-mail.jp","miomio.jp","miobox.jp","e23.jp","x-il.jp"], pop3: {h: "mbox.iijmio-mail.jp", p: 110, t: "tls"}, smtp: {h: "mbox.iijmio-mail.jp", p: 587, t: "tls"}},
    {d: ["ebony.plala.or.jp"], pop3: {h: "ebony.mail.plala.or.jp", p: 110}, smtp: {h: "ebony.mail.plala.or.jp", p: 587}},
    {d: ["elpasotel.net"], imap: {h: "mail.elpasotel.net", p: 993, t: "ssl"}, pop3: {h: "pop3.elpasotel.net", p: 995, t: "ssl"}, smtp: {h: "smtp.elpasotel.net", p: 587, t: "tls"}},
    {d: ["seznam.cz","email.cz","post.cz","spoluzaci.cz"], imap: {h: "imap.seznam.cz", p: 993, t: "ssl"}, pop3: {h: "pop3.seznam.cz", p: 995, t: "ssl"}, smtp: {h: "smtp.seznam.cz", p: 465, t: "ssl"}},
    {d: ["email.it"], imap: {h: "imapmail.email.it", p: 993, t: "ssl"}, pop3: {h: "popmail.email.it", p: 995, t: "ssl"}, smtp: {h: "smtp.email.it", p: 587, t: "tls"}},
    {d: ["email.plala.or.jp"], pop3: {h: "email.mail.plala.or.jp", p: 110}, smtp: {h: "email.mail.plala.or.jp", p: 587}},
    {d: ["emailsrvr.com"], imap: {h: "secure.emailsrvr.com", p: 993, t: "ssl"}, smtp: {h: "secure.emailsrvr.com", p: 465, t: "ssl"}},
    {d: ["ewe.net","ewetel.de","teleos-web.de"], pop3: {h: "pop.ewe.net", p: 995, t: "ssl"}, smtp: {h: "smtp.ewe.net", p: 587, t: "tls"}},
    {d: ["ewetel.de","ewetel.net"], pop3: {h: "pop3s-1.ewetel.net", p: 995, t: "ssl"}, smtp: {h: "smtps-1.ewetel.net", p: 25, t: "tls"}},
    {d: ["fantasy.plala.or.jp"], pop3: {h: "fantasy.mail.plala.or.jp", p: 110}, smtp: {h: "fantasy.mail.plala.or.jp", p: 587}},
    {d: ["fastwebnet.it"], imap: {h: "imap.fastwebnet.it", p: 143, t: "tls"}, smtp: {h: "smtp.fastwebnet.it", p: 587, t: "tls"}},
    {d: ["flamenco.plala.or.jp"], pop3: {h: "flamenco.mail.plala.or.jp", p: 110}, smtp: {h: "flamenco.mail.plala.or.jp", p: 587}},
    {d: ["fmail.plala.or.jp"], pop3: {h: "fmail.mail.plala.or.jp", p: 110}, smtp: {h: "fmail.mail.plala.or.jp", p: 587}},
    {d: ["free.fr"], imap: {h: "imap.free.fr", p: 993, t: "ssl"}, pop3: {h: "pop.free.fr", p: 995, t: "ssl"}, smtp: {h: "smtp.free.fr", p: 25}},
    {d: ["freenet.de"], imap: {h: "mx.freenet.de", p: 993, t: "ssl"}, pop3: {h: "mx.freenet.de", p: 995, t: "ssl"}, smtp: {h: "mx.freenet.de", p: 587, t: "tls"}},
    {d: ["fuga.plala.or.jp"], pop3: {h: "fuga.mail.plala.or.jp", p: 110}, smtp: {h: "fuga.mail.plala.or.jp", p: 587}},
    {d: ["gandi.net"], imap: {h: "mail.gandi.net", p: 993, t: "ssl"}, pop3: {h: "mail.gandi.net", p: 995, t: "ssl"}, smtp: {h: "mail.gandi.net", p: 465, t: "ssl"}},
    {d: ["versatel.de","versanet.de","foni.net","gelsennet.de","telebel.de","telelev.de","cneweb.de","ruhrnet-online.de"], imap: {h: "mx.versatel.de", p: 143}, pop3: {h: "mx.versatel.de", p: 143}, smtp: {h: "smtp.versatel.de", p: 25}},
    {d: ["gigahost.dk"], imap: {h: "mail.gigahost.dk", p: 993, t: "ssl"}, pop3: {h: "mail.gigahost.dk", p: 995, t: "ssl"}, smtp: {h: "smtp.gigahost.dk", p: 587, t: "tls"}},
    {d: ["gmail.com","googlemail.com","google.com","jazztel.es"], imap: {h: "imap.gmail.com", p: 993, t: "ssl"}, pop3: {h: "pop.gmail.com", p: 995, t: "ssl"}, smtp: {h: "smtp.gmail.com", p: 465, t: "ssl"}},
    {d: ["gmail.plala.or.jp"], pop3: {h: "gmail.mail.plala.or.jp", p: 110}, smtp: {h: "gmail.mail.plala.or.jp", p: 587}},
    {d: ["gmx.net","gmx.de","gmx.at","gmx.ch","gmx.eu","gmx.biz","gmx.org","gmx.info"], imap: {h: "imap.gmx.net", p: 993, t: "ssl"}, pop3: {h: "pop.gmx.net", p: 995, t: "ssl"}, smtp: {h: "mail.gmx.net", p: 465, t: "ssl"}},
    {d: ["gmx.com","gmx.tm","gmx.us","gmx.co.uk","gmx.es","gmx.fr","gmx.ca","gmx.cn","gmx.co.in","gmx.com.br","gmx.com.my","gmx.hk","gmx.ie","gmx.ph","gmx.pt","gmx.ru","gmx.se","gmx.sg","gmx.tw","gmx.com.tr","gmx.it","gmx.li"], imap: {h: "imap.gmx.com", p: 993, t: "ssl"}, pop3: {h: "pop.gmx.com", p: 995, t: "ssl"}, smtp: {h: "mail.gmx.com", p: 465, t: "ssl"}},
    {d: ["go.tvm.ne.jp"], pop3: {h: "go.tvm.ne.jp", p: 110}, smtp: {h: "go.tvm.ne.jp", p: 25}},
    {d: ["o2.pl","go2.pl","tlen.pl","prokonto.pl"], pop3: {h: "poczta.o2.pl", p: 995, t: "ssl"}, smtp: {h: "poczta.o2.pl", p: 465, t: "ssl"}},
    {d: ["online.de","onlinehome.de","sofortstart.de","sofort-start.de","sofortsurf.de","sofort-surf.de","go4more.de","kundenserver.de","schlund.de"], imap: {h: "imap.1und1.de", p: 993, t: "ssl"}, pop3: {h: "pop.1und1.de", p: 995, t: "ssl"}, smtp: {h: "smtp.1und1.de", p: 587, t: "tls"}},
    {d: ["goneo.de"], imap: {h: "imap.goneo.de", p: 993, t: "ssl"}, pop3: {h: "pop.goneo.de", p: 995, t: "ssl"}, smtp: {h: "smtp.goneo.de", p: 465, t: "ssl"}},
    {d: ["goo.jp"], pop3: {h: "pop.mail.goo.ne.jp", p: 110}, smtp: {h: "smtp.mail.goo.ne.jp", p: 587}},
    {d: ["gransy.com","internetserver.cz"], imap: {h: "imap.gransy.com", p: 993, t: "ssl"}, pop3: {h: "imap.gransy.com", p: 995, t: "ssl"}, smtp: {h: "smtp.gransy.com", p: 465, t: "ssl"}},
    {d: ["grape.plala.or.jp"], pop3: {h: "grape.mail.plala.or.jp", p: 110}, smtp: {h: "grape.mail.plala.or.jp", p: 587}},
    {d: ["gray.plala.or.jp"], pop3: {h: "gray.mail.plala.or.jp", p: 110}, smtp: {h: "gray.mail.plala.or.jp", p: 587}},
    {d: ["hal.ne.jp"], pop3: {h: "mail.hal.ne.jp", p: 110}, smtp: {h: "mail.hal.ne.jp", p: 587}},
    {d: ["hana.or.jp"], pop3: {h: "mail.hana.or.jp", p: 110}, smtp: {h: "mail.hana.or.jp", p: 587}},
    {d: ["hotmail.com","hotmail.co.uk","hotmail.co.jp","hotmail.com.br","hotmail.de","hotmail.fr","hotmail.it","hotmail.es","live.com","live.co.uk","live.co.jp","live.de","live.fr","live.it","live.jp","msn.com","outlook.com"], imap: {h: "imap-mail.outlook.com", p: 993, t: "ssl"}, pop3: {h: "pop-mail.outlook.com", p: 995, t: "ssl"}, smtp: {h: "smtp-mail.outlook.com", p: 587, t: "tls"}},
    {d: ["i.softbank.jp"], imap: {h: "imap.softbank.jp", p: 993, t: "ssl"}, smtp: {h: "smtp.softbank.jp", p: 465, t: "ssl"}},
    {d: ["ic-net.or.jp"], pop3: {h: "mail.ic-net.or.jp", p: 110}, smtp: {h: "smtp.ic-net.or.jp", p: 587}},
    {d: ["iiyama-catv.ne.jp"], pop3: {h: "mail.iiyama-catv.ne.jp", p: 110}, smtp: {h: "smtp.iiyama-catv.ne.jp", p: 25}},
    {d: ["imail.plala.or.jp"], pop3: {h: "imail.mail.plala.or.jp", p: 110}, smtp: {h: "imail.mail.plala.or.jp", p: 587}},
    {d: ["inbox.lt"], pop3: {h: "mail.inbox.lt", p: 995, t: "ssl"}, smtp: {h: "mail.inbox.lt", p: 587, t: "tls"}},
    {d: ["inbox.lv"], pop3: {h: "mail.inbox.lv", p: 995, t: "ssl"}, smtp: {h: "mail.inbox.lv", p: 587, t: "tls"}},
    {d: ["mail.ru","inbox.ru","list.ru","bk.ru","corp.mail.ru"], imap: {h: "imap.mail.ru", p: 993, t: "ssl"}, pop3: {h: "pop.mail.ru", p: 995, t: "ssl"}, smtp: {h: "smtp.mail.ru", p: 465, t: "ssl"}},
    {d: ["indigo.plala.or.jp"], pop3: {h: "indigo.mail.plala.or.jp", p: 110}, smtp: {h: "indigo.mail.plala.or.jp", p: 587}},
    {d: ["inet-shibata.or.jp"], pop3: {h: "po.inet-shibata.or.jp", p: 110}, smtp: {h: "po.inet-shibata.or.jp", p: 25}},
    {d: ["internode.on.net"], imap: {h: "mail.internode.on.net", p: 993, t: "ssl"}, pop3: {h: "mail.internode.on.net", p: 995, t: "ssl"}, smtp: {h: "mail.internode.on.net", p: 465, t: "ssl"}},
    {d: ["libero.it","iol.it","blu.it","inwind.it"], imap: {h: "imapmail.libero.it", p: 143}, pop3: {h: "popmail.libero.it", p: 110}, smtp: {h: "smtp.libero.it", p: 25}},
    {d: ["ipax.at"], imap: {h: "mail.ipax.at", p: 993, t: "ssl"}, smtp: {h: "mail.ipax.at", p: 465, t: "ssl"}},
    {d: ["ispgateway.de"], imap: {h: "sslmailpool.ispgateway.de", p: 993, t: "ssl"}, pop3: {h: "sslmailpool.ispgateway.de", p: 995, t: "ssl"}, smtp: {h: "smtprelaypool.ispgateway.de", p: 465, t: "ssl"}},
    {d: ["ivory.plala.or.jp"], pop3: {h: "ivory.mail.plala.or.jp", p: 110}, smtp: {h: "ivory.mail.plala.or.jp", p: 587}},
    {d: ["iwafune.ne.jp"], pop3: {h: "po.iwafune.ne.jp", p: 110}, smtp: {h: "po.iwafune.ne.jp", p: 25}},
    {d: ["jade.plala.or.jp"], pop3: {h: "jade.mail.plala.or.jp", p: 110}, smtp: {h: "jade.mail.plala.or.jp", p: 587}},
    {d: ["janis.or.jp"], pop3: {h: "mail.%EMAILDOMAIN%", p: 110}, smtp: {h: "smtp.%EMAILDOMAIN%", p: 25}},
    {d: ["jet.ne.jp"], imap: {h: "imap.jet.ne.jp", p: 993, t: "ssl"}, pop3: {h: "pop.jet.ne.jp", p: 110}, smtp: {h: "smtp.jet.ne.jp", p: 587}},
    {d: ["ji.jet.ne.jp"], pop3: {h: "pop02.jet.ne.jp", p: 110}, smtp: {h: "smtp02.jet.ne.jp", p: 587}},
    {d: ["jmail.plala.or.jp"], pop3: {h: "jmail.mail.plala.or.jp", p: 110}, smtp: {h: "jmail.mail.plala.or.jp", p: 587}},
    {d: ["kl.wind.ne.jp","kl.wind.jp","kl.wind.co.jp","kl.gunmanet.or.jp","kl.gunmanet.ne.jp","k1.wind.ne.jp","k1.wind.jp","k1.gunmanet.or.jp","k1.gunmanet.ne.jp"], pop3: {h: "kl.wind.ne.jp", p: 110}, smtp: {h: "kl.wind.ne.jp", p: 587}},
    {d: ["kabelmail.de"], pop3: {h: "pop3.kabelmail.de", p: 995, t: "ssl"}, smtp: {h: "smtp.kabelmail.de", p: 465, t: "ssl"}},
    {d: ["kelcom.net"], pop3: {h: "pop1.kelcom.net", p: 110}, smtp: {h: "smtp.kelcom.net", p: 25}},
    {d: ["khaki.plala.or.jp"], pop3: {h: "khaki.mail.plala.or.jp", p: 110}, smtp: {h: "khaki.mail.plala.or.jp", p: 587}},
    {d: ["kmail.plala.or.jp"], pop3: {h: "kmail.mail.plala.or.jp", p: 110}, smtp: {h: "kmail.mail.plala.or.jp", p: 587}},
    {d: ["kokuyou.ne.jp"], pop3: {h: "mail.kokuyou.ne.jp", p: 110}, smtp: {h: "smtp.kokuyou.ne.jp", p: 25}},
    {d: ["lapis.plala.or.jp"], pop3: {h: "lapis.mail.plala.or.jp", p: 110}, smtp: {h: "lapis.mail.plala.or.jp", p: 587}},
    {d: ["laposte.net"], imap: {h: "imap.laposte.net", p: 993, t: "ssl"}, pop3: {h: "pop.laposte.net", p: 995, t: "ssl"}, smtp: {h: "smtp.laposte.net", p: 465, t: "ssl"}},
    {d: ["lemon.plala.or.jp"], pop3: {h: "lemon.mail.plala.or.jp", p: 110}, smtp: {h: "lemon.mail.plala.or.jp", p: 587}},
    {d: ["lilac.plala.or.jp"], pop3: {h: "lilac.mail.plala.or.jp", p: 110}, smtp: {h: "lilac.mail.plala.or.jp", p: 587}},
    {d: ["lime.plala.or.jp"], pop3: {h: "lime.mail.plala.or.jp", p: 110}, smtp: {h: "lime.mail.plala.or.jp", p: 587}},
    {d: ["cty-net.ne.jp","cty-net.ne.jp","m2.cty-net.ne.jp","m3.cty-net.ne.jp","m4.cty-net.ne.jp","m5.cty-net.ne.jp","m6.cty-net.ne.jp","m7.cty-net.ne.jp","m8.cty-net.ne.jp","m9.cty-net.ne.jp","cty-net.com"], pop3: {h: "pops.cty-net.ne.jp", p: 995, t: "ssl"}, smtp: {h: "smtps.cty-net.ne.jp", p: 465, t: "ssl"}},
    {d: ["mahoroba.ne.jp"], pop3: {h: "mail.mahoroba.ne.jp", p: 110}, smtp: {h: "mail.mahoroba.ne.jp", p: 587}},
    {d: ["mail.dk"], pop3: {h: "pop3.mail.dk", p: 110}, smtp: {h: "asmtp.mail.dk", p: 587}},
    {d: ["mail.iwafune.ne.jp"], pop3: {h: "mail.iwafune.ne.jp", p: 110}, smtp: {h: "mail.iwafune.ne.jp", p: 25}},
    {d: ["mail.wind.ne.jp","mail.wind.jp","mail.wind.co.jp","mail.gunmanet.or.jp","mail.gunmanet.ne.jp","mail.gunmanet.jp"], pop3: {h: "mail.wind.ne.jp", p: 110}, smtp: {h: "mail.wind.ne.jp", p: 587}},
    {d: ["maroon.plala.or.jp"], pop3: {h: "maroon.mail.plala.or.jp", p: 110}, smtp: {h: "maroon.mail.plala.or.jp", p: 587}},
    {d: ["mac.com","me.com"], imap: {h: "imap.mail.me.com", p: 993, t: "ssl"}, smtp: {h: "smtp.me.com", p: 465, t: "ssl"}},
    {d: ["messagingengine.com"], imap: {h: "mail.messagingengine.com", p: 992, t: "ssl"}, pop3: {h: "mail.messagingengine.com", p: 995, t: "ssl"}, smtp: {h: "mail.messagingengine.com", p: 465, t: "ssl"}},
    {d: ["earthlink.net","mindspring.com","ix.netcom.com"], imap: {h: "imap.earthlink.net", p: 143}, pop3: {h: "pop.earthlink.net", p: 110}, smtp: {h: "smtpauth.earthlink.net", p: 587, t: "tls"}},
    {d: ["minuet.plala.or.jp"], pop3: {h: "minuet.mail.plala.or.jp", p: 110}, smtp: {h: "minuet.mail.plala.or.jp", p: 587}},
    {d: ["ml.murakami.ne.jp"], pop3: {h: "ml.murakami.ne.jp", p: 110}, smtp: {h: "ml.murakami.ne.jp", p: 25}},
    {d: ["pop.shibata.ne.jp","ml.shibata.ne.jp"], pop3: {h: "%EMAILDOMAIN%", p: 110}, smtp: {h: "%EMAILDOMAIN%", p: 25}},
    {d: ["mnet.ne.jp"], pop3: {h: "mail.mnet.ne.jp", p: 110}, smtp: {h: "mail.mnet.ne.jp", p: 587}},
    {d: ["mopera.net"], imap: {h: "mail.mopera.net", p: 993, t: "ssl"}, pop3: {h: "mail.mopera.net", p: 995, t: "ssl"}, smtp: {h: "mail.mopera.net", p: 465, t: "ssl"}},
    {d: ["gmail.com","googlemail.com","google.com","jazztel.es","mozilla.com","mozillafoundation.org"], imap: {h: "imap.googlemail.com", p: 993, t: "ssl"}, pop3: {h: "pop.googlemail.com", p: 995, t: "ssl"}, smtp: {h: "smtp.googlemail.com", p: 465, t: "ssl"}},
    {d: ["mx1.tiki.ne.jp","mx2.et.tiki.ne.jp","mx2.tiki.ne.jp","mx2.wt.tiki.ne.jp","mx3.et.tiki.ne.jp","mx3.tiki.ne.jp","mx4.et.tiki.ne.jp","mx4.tiki.ne.jp","mx5.et.tiki.ne.jp","mx5.tiki.ne.jp","mx6.et.tiki.ne.jp","mx6.tiki.ne.jp","mx7.tiki.ne.jp","mx8.tiki.ne.jp","mx9.tiki.ne.jp","mx21.tiki.ne.jp","mx22.tiki.ne.jp","mx31.tiki.ne.jp","mx32.tiki.ne.jp","mx35.tiki.ne.jp","mx36.tiki.ne.jp","mx41.tiki.ne.jp","mx51.et.tiki.ne.jp","mx51.tiki.ne.jp","mx52.tiki.ne.jp","mx61.tiki.ne.jp","mx71.tiki.ne.jp","mx81.tiki.ne.jp","mx82.tiki.ne.jp","mx91.tiki.ne.jp","ma100.tiki.ne.jp"], pop3: {h: "%EMAILDOMAIN%", p: 110}, smtp: {h: "smtp-auth.tiki.ne.jp", p: 587}},
    {d: ["pec.it","arubapec.it","mypec.eu","gigapec.it","ingpec.eu"], imap: {h: "imaps.pec.aruba.it", p: 993, t: "ssl"}, pop3: {h: "pop3s.pec.aruba.it", p: 993, t: "ssl"}, smtp: {h: "smtps.pec.aruba.it", p: 465, t: "ssl"}},
    {d: ["navy.plala.or.jp"], pop3: {h: "navy.mail.plala.or.jp", p: 110}, smtp: {h: "navy.mail.plala.or.jp", p: 587}},
    {d: ["nifty.com"], pop3: {h: "pop.nifty.com", p: 110}, smtp: {h: "smtp.nifty.com", p: 587}},
    {d: ["nsat.jp"], pop3: {h: "mail.nsat.jp", p: 110}, smtp: {h: "mail.nsat.jp", p: 587}},
    {d: ["ntlworld.com"], imap: {h: "imap.ntlworld.com", p: 993, t: "ssl"}, pop3: {h: "pop3.ntlworld.com", p: 995, t: "ssl"}, smtp: {h: "smtp.ntlworld.com", p: 465, t: "ssl"}},
    {d: ["ocn.ne.jp","ocn.ad.jp"], pop3: {h: "pop.ocn.ne.jp", p: 995, t: "ssl"}, smtp: {h: "smtp.ocn.ne.jp", p: 465, t: "ssl"}},
    {d: ["olive.plala.or.jp"], pop3: {h: "olive.mail.plala.or.jp", p: 110}, smtp: {h: "olive.mail.plala.or.jp", p: 587}},
    {d: ["one.com"], imap: {h: "imap.one.com", p: 993, t: "ssl"}, smtp: {h: "send.one.com", p: 465, t: "ssl"}},
    {d: ["opal.plala.or.jp"], pop3: {h: "opal.mail.plala.or.jp", p: 110}, smtp: {h: "opal.mail.plala.or.jp", p: 587}},
    {d: ["orange.fr","wanadoo.fr"], imap: {h: "imap.orange.fr", p: 993, t: "ssl"}, pop3: {h: "pop.orange.fr", p: 995, t: "ssl"}, smtp: {h: "smtp.orange.fr", p: 465, t: "ssl"}},
    {d: ["orange.plala.or.jp"], pop3: {h: "orange.mail.plala.or.jp", p: 110}, smtp: {h: "orange.mail.plala.or.jp", p: 587}},
    {d: ["orchid.plala.or.jp"], pop3: {h: "orchid.mail.plala.or.jp", p: 110}, smtp: {h: "orchid.mail.plala.or.jp", p: 587}},
    {d: ["ovh.net"], imap: {h: "ssl0.ovh.net", p: 993, t: "ssl"}, pop3: {h: "ssl0.ovh.net", p: 995, t: "ssl"}, smtp: {h: "ssl0.ovh.net", p: 465, t: "ssl"}},
    {d: ["pal.kijimadaira.jp"], pop3: {h: "mail.pal.kijimadaira.jp", p: 110}, smtp: {h: "smtp.pal.kijimadaira.jp", p: 25}},
    {d: ["palette.plala.or.jp"], pop3: {h: "palette.mail.plala.or.jp", p: 110}, smtp: {h: "palette.mail.plala.or.jp", p: 587}},
    {d: ["parabox.or.jp"], pop3: {h: "pop3.parabox.or.jp", p: 110}, smtp: {h: "smtp.parabox.or.jp", p: 25}},
    {d: ["pdx.edu"], imap: {h: "psumail.pdx.edu", p: 993, t: "ssl"}, smtp: {h: "mailhost.pdx.edu", p: 465, t: "ssl"}},
    {d: ["peach.plala.or.jp"], pop3: {h: "peach.mail.plala.or.jp", p: 110}, smtp: {h: "peach.mail.plala.or.jp", p: 587}},
    {d: ["peoplepc.com"], imap: {h: "imap.peoplepc.com", p: 143}, pop3: {h: "pop.peoplepc.com", p: 110}, smtp: {h: "smtpauth.peoplepc.com", p: 587, t: "tls"}},
    {d: ["plum.plala.or.jp"], pop3: {h: "plum.mail.plala.or.jp", p: 110}, smtp: {h: "plum.mail.plala.or.jp", p: 587}},
    {d: ["po.dcn.ne.jp"], pop3: {h: "po.dcn.ne.jp", p: 110}, smtp: {h: "po.dcn.ne.jp", p: 25}},
    {d: ["po.wind.ne.jp","po.wind.jp","po.wind.co.jp","po.gunmanet.or.jp","po.gunmanet.ne.jp"], pop3: {h: "po.wind.ne.jp", p: 110}, smtp: {h: "po.wind.ne.jp", p: 587}},
    {d: ["pobox.com"], imap: {h: "mail.pobox.com", p: 993, t: "ssl"}, pop3: {h: "mail.pobox.com", p: 995, t: "ssl"}, smtp: {h: "smtp.pobox.com", p: 465, t: "ssl"}},
    {d: ["polka.plala.or.jp"], pop3: {h: "polka.mail.plala.or.jp", p: 110}, smtp: {h: "polka.mail.plala.or.jp", p: 587}},
    {d: ["posteo.de","posteo.at","posteo.ch","posteo.org","posteo.eu"], imap: {h: "posteo.de", p: 143, t: "tls"}, smtp: {h: "posteo.de", p: 587, t: "tls"}},
    {d: ["ptd.net"], imap: {h: "promail.ptd.net", p: 993, t: "ssl"}, pop3: {h: "promail.ptd.net", p: 995, t: "ssl"}, smtp: {h: "promail.ptd.net", p: 587, t: "tls"}},
    {d: ["purple.plala.or.jp"], pop3: {h: "purple.mail.plala.or.jp", p: 110}, smtp: {h: "purple.mail.plala.or.jp", p: 587}},
    {d: ["q.com"], imap: {h: "mail.q.com", p: 993, t: "ssl"}, pop3: {h: "mail.q.com", p: 995, t: "ssl"}, smtp: {h: "smtp.q.com", p: 587, t: "tls"}},
    {d: ["qq.com"], imap: {h: "imap.qq.com", p: 993, t: "ssl"}, smtp: {h: "smtp.qq.com", p: 465, t: "ssl"}},
    {d: ["rainbow.plala.or.jp"], pop3: {h: "rainbow.mail.plala.or.jp", p: 110}, smtp: {h: "rainbow.mail.plala.or.jp", p: 587}},
    {d: ["rambler.ru"], imap: {h: "mail.rambler.ru", p: 993, t: "ssl"}, pop3: {h: "mail.rambler.ru", p: 995, t: "ssl"}, smtp: {h: "mail.rambler.ru", p: 465, t: "ssl"}},
    {d: ["red.plala.or.jp"], pop3: {h: "red.mail.plala.or.jp", p: 110}, smtp: {h: "red.mail.plala.or.jp", p: 587}},
    {d: ["rmail.plala.or.jp"], pop3: {h: "rmail.mail.plala.or.jp", p: 110}, smtp: {h: "rmail.mail.plala.or.jp", p: 587}},
    {d: ["yahoo.com","yahoo.de","yahoo.it","yahoo.fr","yahoo.es","yahoo.se","yahoo.co.uk","yahoo.co.nz","yahoo.com.au","yahoo.com.ar","yahoo.com.br","yahoo.com.mx","ymail.com","rocketmail.com","yahoodns.net"], imap: {h: "imap.mail.yahoo.com", p: 993, t: "ssl"}, pop3: {h: "pop.mail.yahoo.com", p: 995, t: "ssl"}, smtp: {h: "smtp.mail.yahoo.com", p: 465, t: "ssl"}},
    {d: ["rondo.plala.or.jp"], pop3: {h: "rondo.mail.plala.or.jp", p: 110}, smtp: {h: "rondo.mail.plala.or.jp", p: 587}},
    {d: ["rose.plala.or.jp"], pop3: {h: "rose.mail.plala.or.jp", p: 110}, smtp: {h: "rose.mail.plala.or.jp", p: 587}},
    {d: ["rouge.plala.or.jp"], pop3: {h: "rouge.mail.plala.or.jp", p: 110}, smtp: {h: "rouge.mail.plala.or.jp", p: 587}},
    {d: ["rr.com"], imap: {h: "mail.twc.com", p: 993, t: "ssl"}, pop3: {h: "mail.twc.com", p: 995, t: "ssl"}, smtp: {h: "mail.twc.com", p: 587, t: "tls"}},
    {d: ["ruby.plala.or.jp"], pop3: {h: "ruby.mail.plala.or.jp", p: 110}, smtp: {h: "ruby.mail.plala.or.jp", p: 587}},
    {d: ["runestone.net"], pop3: {h: "mail.runestone.net", p: 995, t: "ssl"}, smtp: {h: "mail.runestone.net", p: 587, t: "tls"}},
    {d: ["strato.de","rzone.de"], imap: {h: "imap.strato.de", p: 993, t: "ssl"}, pop3: {h: "pop3.strato.de", p: 995, t: "ssl"}, smtp: {h: "smtp.strato.de", p: 465, t: "ssl"}},
    {d: ["sakunet.ne.jp"], pop3: {h: "mail.sakunet.ne.jp", p: 110}, smtp: {h: "smtp.sakunet.ne.jp", p: 25}},
    {d: ["sea.plala.or.jp"], pop3: {h: "sea.mail.plala.or.jp", p: 110}, smtp: {h: "sea.mail.plala.or.jp", p: 587}},
    {d: ["secureserver.net"], imap: {h: "imap.secureserver.net", p: 993, t: "ssl"}, pop3: {h: "pop.secureserver.net", p: 995, t: "ssl"}, smtp: {h: "smtpout.secureserver.net", p: 465, t: "ssl"}},
    {d: ["sepia.plala.or.jp"], pop3: {h: "sepia.mail.plala.or.jp", p: 110}, smtp: {h: "sepia.mail.plala.or.jp", p: 587}},
    {d: ["serenade.plala.or.jp"], pop3: {h: "serenade.mail.plala.or.jp", p: 110}, smtp: {h: "serenade.mail.plala.or.jp", p: 587}},
    {d: ["silk.plala.or.jp"], pop3: {h: "silk.mail.plala.or.jp", p: 110}, smtp: {h: "silk.mail.plala.or.jp", p: 587}},
    {d: ["silver.plala.or.jp"], pop3: {h: "silver.mail.plala.or.jp", p: 110}, smtp: {h: "silver.mail.plala.or.jp", p: 587}},
    {d: ["sky.com"], imap: {h: "imap.tools.sky.com", p: 993, t: "ssl"}, pop3: {h: "pop.tools.sky.com", p: 995, t: "ssl"}, smtp: {h: "smtp.tools.sky.com", p: 465, t: "ssl"}},
    {d: ["sky.plala.or.jp"], pop3: {h: "sky.mail.plala.or.jp", p: 110}, smtp: {h: "sky.mail.plala.or.jp", p: 587}},
    {d: ["smail.plala.or.jp"], pop3: {h: "smail.mail.plala.or.jp", p: 110}, smtp: {h: "smail.mail.plala.or.jp", p: 587}},
    {d: ["snow.plala.or.jp"], pop3: {h: "snow.mail.plala.or.jp", p: 110}, smtp: {h: "snow.mail.plala.or.jp", p: 587}},
    {d: ["so.wind.ne.jp","so.wind.jp"], imap: {h: "so.wind.ne.jp", p: 143}, smtp: {h: "so.wind.ne.jp", p: 587}},
    {d: ["sonata.plala.or.jp"], pop3: {h: "sonata.mail.plala.or.jp", p: 110}, smtp: {h: "sonata.mail.plala.or.jp", p: 587}},
    {d: ["studenti.univr.it"], imap: {h: "univr.mail.cineca.it", p: 993, t: "ssl"}, pop3: {h: "univr.mail.cineca.it", p: 995, t: "ssl"}, smtp: {h: "univr.smtpauth.cineca.it", p: 465, t: "ssl"}},
    {d: ["suite.plala.or.jp"], pop3: {h: "suite.mail.plala.or.jp", p: 110}, smtp: {h: "suite.mail.plala.or.jp", p: 587}},
    {d: ["symphony.plala.or.jp"], pop3: {h: "symphony.mail.plala.or.jp", p: 110}, smtp: {h: "symphony.mail.plala.or.jp", p: 587}},
    {d: ["t-online.de"], imap: {h: "secureimap.t-online.de", p: 993, t: "ssl"}, pop3: {h: "securepop.t-online.de", p: 995, t: "ssl"}, smtp: {h: "securesmtp.t-online.de", p: 587, t: "tls"}},
    {d: ["taupe.plala.or.jp"], pop3: {h: "taupe.mail.plala.or.jp", p: 110}, smtp: {h: "taupe.mail.plala.or.jp", p: 587}},
    {d: ["terra.es"], imap: {h: "imap4.terra.es", p: 143}, pop3: {h: "pop3.terra.es", p: 110}, smtp: {h: "mailhost.terra.es", p: 25}},
    {d: ["thinline.cz"], imap: {h: "mail.cesky-hosting.cz", p: 993, t: "ssl"}, pop3: {h: "mail.cesky-hosting.cz", p: 995, t: "ssl"}, smtp: {h: "smtp.cesky-hosting.cz", p: 465, t: "ssl"}},
    {d: ["tiki.ne.jp"], pop3: {h: "mx.tiki.ne.jp", p: 110}, smtp: {h: "smtp-auth.tiki.ne.jp", p: 587}},
    {d: ["tiscali.it"], imap: {h: "imap.tiscali.it", p: 993, t: "ssl"}, pop3: {h: "pop.tiscali.it", p: 995, t: "ssl"}, smtp: {h: "smtp.tiscali.it", p: 465, t: "ssl"}},
    {d: ["tmail.plala.or.jp"], pop3: {h: "tmail.mail.plala.or.jp", p: 110}, smtp: {h: "tmail.mail.plala.or.jp", p: 587}},
    {d: ["toccata.plala.or.jp"], pop3: {h: "toccata.mail.plala.or.jp", p: 110}, smtp: {h: "toccata.mail.plala.or.jp", p: 587}},
    {d: ["topaz.plala.or.jp"], pop3: {h: "topaz.mail.plala.or.jp", p: 110}, smtp: {h: "topaz.mail.plala.or.jp", p: 587}},
    {d: ["trio.plala.or.jp"], pop3: {h: "trio.mail.plala.or.jp", p: 110}, smtp: {h: "trio.mail.plala.or.jp", p: 587}},
    {d: ["umail.plala.or.jp"], pop3: {h: "umail.mail.plala.or.jp", p: 110}, smtp: {h: "umail.mail.plala.or.jp", p: 587}},
    {d: ["umich.edu"], imap: {h: "mail.umich.edu", p: 993, t: "ssl"}, smtp: {h: "smtp.mail.umich.edu", p: 587, t: "tls"}},
    {d: ["uol.com.br"], imap: {h: "imap.uol.com.br", p: 993, t: "ssl"}, pop3: {h: "pop3.uol.com.br", p: 995, t: "ssl"}, smtp: {h: "smtps.uol.com.br", p: 587, t: "tls"}},
    {d: ["upcmail.nl","chello.nl"], pop3: {h: "pop3.upcmail.nl", p: 110}, smtp: {h: "smtp.upcmail.nl", p: 25}},
    {d: ["verizon.net"], pop3: {h: "pop.verizon.net", p: 995, t: "ssl"}, smtp: {h: "smtp.verizon.net", p: 465, t: "ssl"}},
    {d: ["violet.plala.or.jp"], pop3: {h: "violet.mail.plala.or.jp", p: 110}, smtp: {h: "violet.mail.plala.or.jp", p: 587}},
    {d: ["virgin.net"], imap: {h: "imap4.virgin.net", p: 993, t: "ssl"}, pop3: {h: "pop.virgin.net", p: 995, t: "ssl"}, smtp: {h: "smtp.virgin.net", p: 465, t: "ssl"}},
    {d: ["virginmedia.com"], imap: {h: "imap.virginmedia.com", p: 993, t: "ssl"}, pop3: {h: "pop3.virginmedia.com", p: 995, t: "ssl"}, smtp: {h: "smtp.virginmedia.com", p: 465, t: "ssl"}},
    {d: ["vm.aikis.or.jp"], pop3: {h: "mail.aikis.or.jp", p: 995, t: "ssl"}, smtp: {h: "mail.aikis.or.jp", p: 587, t: "tls"}},
    {d: ["vmail.plala.or.jp"], pop3: {h: "vmail.mail.plala.or.jp", p: 110}, smtp: {h: "vmail.mail.plala.or.jp", p: 587}},
    {d: ["vp.tiki.ne.jp"], pop3: {h: "vp.tiki.ne.jp", p: 110}, smtp: {h: "vs.tiki.ne.jp", p: 587}},
    {d: ["waltz.plala.or.jp"], pop3: {h: "waltz.mail.plala.or.jp", p: 110}, smtp: {h: "waltz.mail.plala.or.jp", p: 587}},
    {d: ["wave.plala.or.jp"], pop3: {h: "wave.mail.plala.or.jp", p: 110}, smtp: {h: "wave.mail.plala.or.jp", p: 587}},
    {d: ["web.de"], imap: {h: "imap.web.de", p: 993, t: "ssl"}, pop3: {h: "pop3.web.de", p: 995, t: "ssl"}, smtp: {h: "smtp.web.de", p: 587, t: "tls"}},
    {d: ["webhuset.no"], imap: {h: "imap.webhuset.no", p: 993, t: "ssl"}, pop3: {h: "mail.webhuset.no", p: 995, t: "ssl"}, smtp: {h: "smtp.webhuset.no", p: 465, t: "ssl"}},
    {d: ["white.plala.or.jp"], pop3: {h: "white.mail.plala.or.jp", p: 110}, smtp: {h: "white.mail.plala.or.jp", p: 587}},
    {d: ["wine.plala.or.jp"], pop3: {h: "wine.mail.plala.or.jp", p: 110}, smtp: {h: "wine.mail.plala.or.jp", p: 587}},
    {d: ["wmail.plala.or.jp"], pop3: {h: "wmail.mail.plala.or.jp", p: 110}, smtp: {h: "wmail.mail.plala.or.jp", p: 587}},
    {d: ["tiscali.cz","wo.cz","worldonline.cz","worldmail.cz"], pop3: {h: "pop3.mail.tiscali.cz", p: 110}, smtp: {h: "smtp.mail.tiscali.cz", p: 25}},
    {d: ["wp.pl"], imap: {h: "imap.wp.pl", p: 993, t: "ssl"}, pop3: {h: "pop3.wp.pl", p: 995, t: "ssl"}, smtp: {h: "smtp.wp.pl", p: 465, t: "ssl"}},
    {d: ["xmail.plala.or.jp"], pop3: {h: "xmail.mail.plala.or.jp", p: 110}, smtp: {h: "xmail.mail.plala.or.jp", p: 587}},
    {d: ["xp.wind.jp"], pop3: {h: "xp.wind.jp", p: 110}, smtp: {h: "xp.wind.jp", p: 587}},
    {d: ["xpost.plala.or.jp"], pop3: {h: "xpost.mail.plala.or.jp", p: 110}, smtp: {h: "xpost.mail.plala.or.jp", p: 587}},
    {d: ["xs4all.nl"], pop3: {h: "pops.xs4all.nl", p: 995, t: "ssl"}, smtp: {h: "smtps.xs4all.nl", p: 465, t: "ssl"}},
    {d: ["xtra.co.nz"], pop3: {h: "pop3.xtra.co.nz", p: 995, t: "ssl"}, smtp: {h: "send.xtra.co.nz", p: 465, t: "ssl"}},
    {d: ["yahoo.co.jp"], pop3: {h: "pop.mail.yahoo.co.jp", p: 995, t: "ssl"}, smtp: {h: "smtp.mail.yahoo.co.jp", p: 465, t: "ssl"}},
    {d: ["yandex.ru","yandex.com","yandex.net","yandex.by","yandex.kz","yandex.ua","ya.ru","narod.ru"], imap: {h: "imap.yandex.com", p: 993, t: "ssl"}, pop3: {h: "pop.yandex.com", p: 995, t: "ssl"}, smtp: {h: "smtp.yandex.com", p: 465, t: "ssl"}},
    {d: ["ybb.ne.jp"], pop3: {h: "ybbpop.mail.yahoo.co.jp", p: 995, t: "ssl"}, smtp: {h: "ybbsmtp.mail.yahoo.co.jp", p: 465, t: "ssl"}},
    {d: ["yeah.net"], imap: {h: "imap.yeah.net", p: 993, t: "ssl"}, smtp: {h: "smtp.yeah.net", p: 465, t: "ssl"}},
    {d: ["yellow.plala.or.jp"], pop3: {h: "yellow.mail.plala.or.jp", p: 110}, smtp: {h: "yellow.mail.plala.or.jp", p: 587}},
    {d: ["ymail.plala.or.jp"], pop3: {h: "ymail.mail.plala.or.jp", p: 110}, smtp: {h: "ymail.mail.plala.or.jp", p: 587}},
    {d: ["ypost.plala.or.jp"], pop3: {h: "ypost.mail.plala.or.jp", p: 110}, smtp: {h: "ypost.mail.plala.or.jp", p: 587}},
    {d: ["zeelandnet.nl"], imap: {h: "mail.zeelandnet.nl", p: 993, t: "ssl"}, pop3: {h: "mail.zeelandnet.nl", p: 995, t: "ssl"}, smtp: {h: "mail.zeelandnet.nl", p: 465, t: "ssl"}},
    {d: ["zmail.plala.or.jp"], pop3: {h: "zmail.mail.plala.or.jp", p: 110}, smtp: {h: "zmail.mail.plala.or.jp", p: 587}},
    {d: ["zpost.plala.or.jp"], pop3: {h: "zpost.mail.plala.or.jp", p: 110}, smtp: {h: "zpost.mail.plala.or.jp", p: 587}}];
}
