var folders         = window.arguments[0].inn.folders;
var folderTree      = window.arguments[0].inn.folderTree;
var folderTreeView  = window.arguments[0].inn.folderTreeView;
var messageTreeView = window.arguments[0].inn.messageTreeView;
var storage;

var SimpleMailSPAM = {
  initialize: function() {
    simplemail.overlay = simplemail.getBrowserWindow().simplemail.overlay;
    storage = simplemail.overlay.storage;

    simplemail.SimpleMailPrefs.getBool("movespam") ? simplemail.domGet("styleSPAM").selectedIndex = 0
                                             : simplemail.SimpleMailPrefs.getBool("trashspam") ? simplemail.domGet("styleSPAM").selectedIndex = 1
                                             : simplemail.SimpleMailPrefs.getBool("deletespam") ? simplemail.domGet("styleSPAM").selectedIndex = 2
                                             : simplemail.domGet("styleSPAM").selectedIndex = 3;
                                             
    if (simplemail.SimpleMailPrefs.getBool("movespam"))
      checkFolderSPAMPrefs();

    if (simplemail.SimpleMailPrefs.getBool("nospam"))
      simplemail.domGet('markspamasread').disabled = true;

    simplemail.domGet("markspamasread").checked = simplemail.SimpleMailPrefs.getBool("markspamasread");
  }
};

// userok: async
function checkFolderSPAMPrefs() {
  var folderSPAM = "SPAM";
  var spamFolderId = simplemail.SimpleMailManageFolder.getFolderId(folderSPAM);

  if (typeof(spamFolderId) == 'undefined') {
    var spamFolder = "SPAM";
    var folderSPAM = new simplemail.Folder(null, null, spamFolder);
    folderTree.view = folderTreeView;
    simplemail.SimpleMailManageFolder.setFolderParent(function(fldr, pid) {
      folders      = storage.getFolders();
      folderTree   = simplemail.domGet("folder-tree");
      simplemail.SimpleMailManageFolder.updateFolderCounts();
      spamFolderId = fldr.id;      
    }, folderSPAM, 0);
  }
}

function styleSPAM(selectedIndex) {
  if (simplemail.domGet("styleSPAM").selectedIndex == 0) {
    simplemail.SimpleMailPrefs.setBool('movespam', true);
    simplemail.SimpleMailPrefs.setBool('trashspam', false);
    simplemail.SimpleMailPrefs.setBool('deletespam', false);
    simplemail.SimpleMailPrefs.setBool('nospam', false);
    simplemail.domGet('markspamasread').disabled = false;
    checkFolderSPAMPrefs();
    checkChangeActions();
  } else if (simplemail.domGet("styleSPAM").selectedIndex == 1){
    simplemail.SimpleMailPrefs.setBool('movespam', false);
    simplemail.SimpleMailPrefs.setBool('trashspam', true);
    simplemail.SimpleMailPrefs.setBool('deletespam', false);
    simplemail.SimpleMailPrefs.setBool('nospam', false);
    simplemail.domGet('markspamasread').disabled = false;
    checkChangeActions();
  } else if (simplemail.domGet("styleSPAM").selectedIndex == 2){
    simplemail.SimpleMailPrefs.setBool('movespam', false);
    simplemail.SimpleMailPrefs.setBool('trashspam', false);
    simplemail.SimpleMailPrefs.setBool('deletespam', true);
    simplemail.SimpleMailPrefs.setBool('nospam', false);
    simplemail.domGet('markspamasread').disabled = false;
    checkChangeActions();
  } else if (simplemail.domGet("styleSPAM").selectedIndex == 3){
    simplemail.SimpleMailPrefs.setBool('movespam', false);
    simplemail.SimpleMailPrefs.setBool('trashspam', false);
    simplemail.SimpleMailPrefs.setBool('deletespam', false);
    simplemail.SimpleMailPrefs.setBool('nospam', true);
    simplemail.SimpleMailPrefs.setBool('markspamasread', false);
    simplemail.domGet('markspamasread').disabled = true;
    checkChangeActions();
  }
}

function onCancel() {
  var mainWindow = simplemail.overlay.getMainWindow(true);
  window.close();
  if (mainWindow) 
    mainWindow.history.go();
  simplemail.overlay.spamWindow.focus();
}